# TODO:
# - enable internalization support (BR libftgl)
# - libsolid/libqhull/libode BR ?
Summary:	3D modeling, rendering, animation and game creation package
Summary(pl.UTF-8):	Pakiet do tworzenia animacji 3D oraz gier
Name:		blender
Version:	3.1.0
Release:	2
License:	GPL
Group:		X11/Applications/Graphics
Source0:	https://download.blender.org/source/%{name}-%{version}.tar.xz
# Source0-md5:	483e16f010cc8c2363ba05b716fde3d0
Patch0:		%{name}-2.76-droid.patch
Patch1:		format-security.patch
URL:		https://www.blender.org/
BuildRequires:	OpenAL-devel
BuildRequires:	OpenColorIO-devel
BuildRequires:	OpenEXR-devel
BuildRequires:	OpenGL-devel
BuildRequires:	OpenGL-GLU-devel
BuildRequires:	OpenImageIO-devel
BuildRequires:	SDL2-devel
BuildRequires:	boost-devel
BuildRequires:	cmake
BuildRequires:	embree-devel
BuildRequires:	ffmpeg-devel >= 0.4.9-4.20080930.1
BuildRequires:	fftw3-devel
BuildRequires:	freealut-devel
BuildRequires:	freetype-devel
BuildRequires:	ftgl-devel
BuildRequires:	gcc >= 5:3.4.0
BuildRequires:	gettext-tools
BuildRequires:	glew-devel
BuildRequires:	jack-audio-connection-kit-devel
BuildRequires:	jemalloc-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libsndfile-devel
BuildRequires:	libspnav-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtiff-devel
BuildRequires:	libtool
BuildRequires:	libvorbis-devel
BuildRequires:	openjpeg2-devel
BuildRequires:	openssl-devel >= 0.9.7d
BuildRequires:	pugixml-devel
BuildRequires:	python3 >= 1:3.10
BuildRequires:	python3-devel >= 1:3.10
BuildRequires:	python3-numpy-devel
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.385
BuildRequires:	sed >= 4.0
BuildRequires:	xorg-lib-libXi-devel
BuildRequires:	zlib-devel
Requires(post,postun):	desktop-file-utils
Requires:	OpenGL
Requires:	freetype
Requires:	python3-modules >= 1:3.10
ExclusiveArch:	%{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreqdep	libGL.so.1 libGLU.so.1

%description
Blender is a free and fully functional 3D modeling, rendering,
animation and game creation package for Unix, Windows and BeOS
systems.

%description -l pl.UTF-8
Blender to darmowy i w pełni funkcjonalny pakiet do tworzenia animacji
3D oraz gier, dostępny dla systemów Unix, Windows i BeOS.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%{__sed} -E -i -e '1s,#!\s*/usr/bin/env\s+python(\s|$),#!%{__python3}\1,' -e '1s,#!\s*/usr/bin/env\s+python3(\s|$),#!%{__python3}\1,' \
      release/scripts/addons/io_curve_svg/svg_util_test.py \
      release/scripts/addons/io_scene_fbx/fbx2json.py \
      release/scripts/addons/io_scene_fbx/json2fbx.py \
      release/scripts/addons/sun_position/geo.py \
      release/scripts/modules/bl_i18n_utils/merge_po.py \
      release/scripts/modules/bl_i18n_utils/utils_rtl.py \
      release/scripts/modules/blend_render_info.py

%build
install -d build
cd build
%cmake \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=OFF \
	-DWITH_FFTW3:BOOL=ON \
	-DWITH_JACK:BOOL=ON \
	-DWITH_JACK_DYNLOAD:BOOL=ON \
	-DWITH_CODEC_SNDFILE:BOOL=ON \
	-DWITH_IMAGE_OPENJPEG:BOOL=ON \
	-DWITH_OPENCOLLADA:BOOL=ON \
	-DWITH_OPENCOLORIO:BOOL=ON \
	-DWITH_CYCLES:BOOL=ON \
	-DWITH_FFTW3:BOOL=ON \
	-DWITH_MOD_OCEANSIM:BOOL=ON \
	-DOPENCOLLADA=%{_includedir} \
	-DWITH_PYTHON:BOOL=ON \
	-DPYTHON_VERSION:STRING=%{py3_ver} \
	-DWITH_PYTHON_INSTALL:BOOL=OFF \
	-DWITH_CODEC_FFMPEG:BOOL=ON \
	-DWITH_GAMEENGINE:BOOL=ON \
	-DWITH_CXX_GUARDEDALLOC:BOOL=OFF \
	-DWITH_INSTALL_PORTABLE:BOOL=OFF \
	-DWITH_PYTHON_SAFETY:BOOL=ON \
	-DWITH_PLAYER:BOOL=ON \
	-DWITH_MEM_JEMALLOC:BOOL=ON \
	-DWITH_SYSTEM_GLEW:BOOL=ON \
	-DBOOST_ROOT=%{_prefix} \
	-DWITH_INPUT_NDOF:BOOL=ON \
	-DWITH_SDL:BOOL=ON \
	-DWITH_SDL_DYNLOAD:BOOL=ON \
	..

%{__make} V=1

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_desktopdir},%{_pixmapsdir},%{_mandir}/man1}

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

./doc/manpage/blender.1.py \
	--blender $RPM_BUILD_ROOT%{_bindir}/blender \
	--output $RPM_BUILD_ROOT%{_mandir}/man1/blender.1

#%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_desktop_database_post

%postun
%update_desktop_database_postun

%files
%defattr(644,root,root,755)
# -f %{name}.lang
%doc doc/license/bf-members.txt doc/guides/*.txt
%attr(755,root,root) %{_bindir}/blender
%attr(755,root,root) %{_bindir}/blender-thumbnailer
%attr(755,root,root) %{_datadir}/%{name}
%{_desktopdir}/*.desktop
%{_iconsdir}/hicolor/scalable/apps/blender.svg
%{_iconsdir}/hicolor/symbolic/apps/blender-symbolic.svg
%{_mandir}/man1/*
%changelog
* Mon Jun 06 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/blender.git;a=log;h=master

* Mon Jun 06 2022 Jan Palus <atler@pld-linux.org> 822e101
- boost rebuild

* Tue Apr 05 2022 Jan Rękorajski <baggins@pld-linux.org> ba7734f
- up to 3.1.0

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> de5b15c
- Release 3 (by relup.sh)

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> fc47354
- rebuild with python 3.10

* Sun Feb 13 2022 Jan Rękorajski <baggins@pld-linux.org> 4ec3633
- up to 3.0.1

* Wed Jan 19 2022 Jan Palus <atler@pld-linux.org> c12d53a
- boost rebuild

* Thu Dec 16 2021 Jan Palus <atler@pld-linux.org> 1e67cae
- tbb rebuild

* Wed Aug 11 2021 Jan Palus <atler@pld-linux.org> 5600040
- boost rebuild

* Sat Mar 06 2021 Jan Rękorajski <baggins@pld-linux.org> 391429c
- up to 2.83.12
- add patch from debian to fix build with python 3.9

* Sat Aug 01 2020 Jan Rękorajski <baggins@pld-linux.org> 8656a83
- release 3 (by relup.sh)

* Thu Mar 26 2020 Jan Rękorajski <baggins@pld-linux.org> e1d8fb9
- x32 builds with default setting again
- rel 2

* Thu Mar 26 2020 Jan Rękorajski <baggins@pld-linux.org> 64da38a
- fix struct member name conflict

* Wed Mar 25 2020 Jan Rękorajski <baggins@pld-linux.org> de35b31
- up to 2.82a

* Wed Mar 25 2020 Jan Rękorajski <baggins@pld-linux.org> 5e4c02e
- release 2 (by relup.sh)

* Sat Dec 14 2019 Jan Rękorajski <baggins@pld-linux.org> 7ecf819
- up to 2.81a

* Sat Nov 02 2019 Jan Rękorajski <baggins@pld-linux.org> 54675d1
- updated deps
- fix build with python 3.8
- rel 3

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> e137a46
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun Oct 13 2019 Jan Rękorajski <baggins@pld-linux.org> 4b09735
- up to 2.80

* Sat May 11 2019 Jan Rękorajski <baggins@pld-linux.org> ae7eb72
- release 4 (by relup.sh)

* Mon Apr 22 2019 Jan Rękorajski <baggins@pld-linux.org> 3adce53
- add OpenImageIO 2 build fix from fedora
- rel 3

